/*
 * Injected Javascript for BlockGoogleRedir extension.
 *
 * This script is executed after loading a page
 * from a matching URL (Google search result pages).
 */

(function () {

  var timerRunning = 0;

  /* Add stylesheet rule.
     It would be cleaner to do this via the contentStyleFile option of page-mod
     but that does not work properly. */
  var addstyle = function() {
    var css = "a.blockgr:link { color: #037 !important; }";
    var head = document.getElementsByTagName("head")[0];
    if (head) {
      var style = document.createElement("style");
      style.appendChild(document.createTextNode(css));
      style.setAttribute("type", "text/css");
      head.appendChild(style);
    }
  }

  /* Traverse document tree and fix evil links. */
  var checklinks = function() {

//console.log("BlockGoogleRedir: checklinks");

    timerRunning = 0;

    var nrewrite = 0;
    var nunbooby = 0;

    var links = document.getElementsByTagName("a");
    for (var i = 0; i < links.length; i++) {
      var a = links[i];

      /* Only process result links. */
      if (a.href &&
          (a.className == "l" ||
           (a.parentNode && a.parentNode.tagName.toUpperCase() == "H3") ||
           (a.parentNode && a.parentNode.tagName.toUpperCase() == "DIV" &&
            a.parentNode.className == "osl"))) {

        var m = a.href.match(/^(https?:\/\/www\.google\.[a-z]{2,3}(\.[a-z]{2})?)?\/url\?/);
        if (m) {
          /* This is a link to the Google result redirection service.
             Rewrite the link target to point directly to the search result. */
          var props = a.href.substring(m[0].length).split("&");
          for (var j = 0; j < props.length; j++) {
            var p = props[j];
            if (p.substring(0, 2) == "q=") {
              var target = unescape(p.substring(2));
              a.href = target;
              if (a.rel) {
                if (a.rel.indexOf("noreferrer") < 0)
                  a.rel = a.rel + " noreferrer";
              } else {
                a.rel = "noreferrer";
              }
              a.className = "blockgr" + (a.className ? (" " + a.className) : "");
            }
          }
//a.insertBefore(document.createTextNode("rewrite:"), a.firstChild);
          nrewrite++;
        }

        if (a.hasAttribute("onmousedown")) {
          /* This is a booby-trapped link which will flip its target when
             the user clicks on it. Copy the useful stuff to a new <A> element,
             then destroy the original link. */
          var na = document.createElement("a");
          na.href = a.href;
          na.rel = "noreferrer";
          na.className = "blockgr" + (a.className ? (" " + a.className) : "");
          a.parentNode.insertBefore(na, a);
          for (var nd = a.firstChild; nd; ) {
            var nnd = nd.nextSibling;
            if (nd.nodeType == 1 || nd.nodeType == 3)
              na.appendChild(a.removeChild(nd));
            nd = nnd;
          }
          a.parentNode.removeChild(a);
//na.insertBefore(document.createTextNode("unbooby:"), na.firstChild);
          nunbooby++;
        }

      }
    }

//console.log("BlockGoogleRedir: " + nrewrite + " links rewritten; " + nunbooby + " event handlers stripped");
  }

  /* Called when DOM tree is modified. */
  var treemodified = function() {
    if (!timerRunning) {
      timerRunning = 1;
      window.setTimeout(checklinks, 100);
    }
  }

  /* This part runs when the document is loaded. */
  addstyle();
  document.addEventListener("DOMSubtreeModified", treemodified, false);
  checklinks();

})();

